package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.GuideTipImage;
import com.izouma.awesomeadmin.service.GuideTipImageService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/guideTipImage")
public class GuideTipImageController {

    @Autowired
    private GuideTipImageService guideTipImageService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(GuideTipImage record) {
        List<GuideTipImage> pp = guideTipImageService.getGuideTipImageList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getGuideTipImage", method = RequestMethod.GET)
    @ResponseBody
    public Result getGuideTipImage(@RequestParam(required = false, value = "id") String id) {
        GuideTipImage data = guideTipImageService.getGuideTipImageById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(GuideTipImage record) {
        GuideTipImage data = guideTipImageService.getGuideTipImage(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, GuideTipImage record) {
        Map<String, Object> result = new HashMap<>();

        List<GuideTipImage> pp =guideTipImageService.getGuideTipImageByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(GuideTipImage record) {
        boolean num = guideTipImageService.createGuideTipImage(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateGuideTipImage(GuideTipImage record) {
        boolean num = guideTipImageService.updateGuideTipImage(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteGuideTipImage(GuideTipImage record) {

        boolean num = guideTipImageService.deleteGuideTipImage(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, GuideTipImage record) throws Exception {

    List<GuideTipImage> guideTipImages = guideTipImageService.getGuideTipImageList(record);


        String sheetName = "guide_tip_image";
        String titleName = "引导图信息表数据表";
        String fileName = "引导图信息表表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "策划备注" ,   "编号" ,   "扫码图名称"  };
        String[][] dataList = new String[guideTipImages.size()][9];

        for (int i = 0; i < guideTipImages.size(); i++) {

                        dataList[i][0] = String.valueOf(guideTipImages.get(i).getId());
                        dataList[i][1] = String.valueOf(guideTipImages.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(guideTipImages.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(guideTipImages.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(guideTipImages.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(guideTipImages.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(guideTipImages.get(i).getRemark());
                        dataList[i][7] = String.valueOf(guideTipImages.get(i).getMarketId());
                        dataList[i][8] = String.valueOf(guideTipImages.get(i).getImageName());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

